Index: src/vector.cpp
===================================================================
--- src/vector.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/vector.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -28,8 +28,8 @@
 double Vector::DistanceSquared(const Vector *y) const
 {
-	double res = 0.;
-	for (int i=NDIM;i--;)
-		res += (x[i]-y->x[i])*(x[i]-y->x[i]);
-	return (res);
+  double res = 0.;
+  for (int i=NDIM;i--;)
+    res += (x[i]-y->x[i])*(x[i]-y->x[i]);
+  return (res);
 };
 
@@ -40,8 +40,8 @@
 double Vector::Distance(const Vector *y) const
 {
-	double res = 0.;
-	for (int i=NDIM;i--;)
-		res += (x[i]-y->x[i])*(x[i]-y->x[i]);
-	return (sqrt(res));
+  double res = 0.;
+  for (int i=NDIM;i--;)
+    res += (x[i]-y->x[i])*(x[i]-y->x[i]);
+  return (sqrt(res));
 };
 
@@ -53,33 +53,33 @@
 double Vector::PeriodicDistance(const Vector *y, const double *cell_size) const
 {
-	double res = Distance(y), tmp, matrix[NDIM*NDIM];
-	Vector Shiftedy, TranslationVector;
-	int N[NDIM];
-	matrix[0] = cell_size[0];
-	matrix[1] = cell_size[1];
-	matrix[2] = cell_size[3];
-	matrix[3] = cell_size[1];
-	matrix[4] = cell_size[2];
-	matrix[5] = cell_size[4];
-	matrix[6] = cell_size[3];
-	matrix[7] = cell_size[4];
-	matrix[8] = cell_size[5];
-	// in order to check the periodic distance, translate one of the vectors into each of the 27 neighbouring cells
-	for (N[0]=-1;N[0]<=1;N[0]++)
-		for (N[1]=-1;N[1]<=1;N[1]++)
-			for (N[2]=-1;N[2]<=1;N[2]++) {
-				// create the translation vector
-				TranslationVector.Zero();
-				for (int i=NDIM;i--;)
-					TranslationVector.x[i] = (double)N[i];
-				TranslationVector.MatrixMultiplication(matrix);
-				// add onto the original vector to compare with
-				Shiftedy.CopyVector(y);
-				Shiftedy.AddVector(&TranslationVector);
-				// get distance and compare with minimum so far
-				tmp = Distance(&Shiftedy);
-				if (tmp < res) res = tmp;
-			}
-	return (res);
+  double res = Distance(y), tmp, matrix[NDIM*NDIM];
+  Vector Shiftedy, TranslationVector;
+  int N[NDIM];
+  matrix[0] = cell_size[0];
+  matrix[1] = cell_size[1];
+  matrix[2] = cell_size[3];
+  matrix[3] = cell_size[1];
+  matrix[4] = cell_size[2];
+  matrix[5] = cell_size[4];
+  matrix[6] = cell_size[3];
+  matrix[7] = cell_size[4];
+  matrix[8] = cell_size[5];
+  // in order to check the periodic distance, translate one of the vectors into each of the 27 neighbouring cells
+  for (N[0]=-1;N[0]<=1;N[0]++)
+    for (N[1]=-1;N[1]<=1;N[1]++)
+      for (N[2]=-1;N[2]<=1;N[2]++) {
+        // create the translation vector
+        TranslationVector.Zero();
+        for (int i=NDIM;i--;)
+          TranslationVector.x[i] = (double)N[i];
+        TranslationVector.MatrixMultiplication(matrix);
+        // add onto the original vector to compare with
+        Shiftedy.CopyVector(y);
+        Shiftedy.AddVector(&TranslationVector);
+        // get distance and compare with minimum so far
+        tmp = Distance(&Shiftedy);
+        if (tmp < res) res = tmp;
+      }
+  return (res);
 };
 
@@ -91,33 +91,33 @@
 double Vector::PeriodicDistanceSquared(const Vector *y, const double *cell_size) const
 {
-	double res = DistanceSquared(y), tmp, matrix[NDIM*NDIM];
-	Vector Shiftedy, TranslationVector;
-	int N[NDIM];
-	matrix[0] = cell_size[0];
-	matrix[1] = cell_size[1];
-	matrix[2] = cell_size[3];
-	matrix[3] = cell_size[1];
-	matrix[4] = cell_size[2];
-	matrix[5] = cell_size[4];
-	matrix[6] = cell_size[3];
-	matrix[7] = cell_size[4];
-	matrix[8] = cell_size[5];
-	// in order to check the periodic distance, translate one of the vectors into each of the 27 neighbouring cells
-	for (N[0]=-1;N[0]<=1;N[0]++)
-		for (N[1]=-1;N[1]<=1;N[1]++)
-			for (N[2]=-1;N[2]<=1;N[2]++) {
-				// create the translation vector
-				TranslationVector.Zero();
-				for (int i=NDIM;i--;)
-					TranslationVector.x[i] = (double)N[i];
-				TranslationVector.MatrixMultiplication(matrix);
-				// add onto the original vector to compare with
-				Shiftedy.CopyVector(y);
-				Shiftedy.AddVector(&TranslationVector);
-				// get distance and compare with minimum so far
-				tmp = DistanceSquared(&Shiftedy);
-				if (tmp < res) res = tmp;
-			}
-	return (res);
+  double res = DistanceSquared(y), tmp, matrix[NDIM*NDIM];
+  Vector Shiftedy, TranslationVector;
+  int N[NDIM];
+  matrix[0] = cell_size[0];
+  matrix[1] = cell_size[1];
+  matrix[2] = cell_size[3];
+  matrix[3] = cell_size[1];
+  matrix[4] = cell_size[2];
+  matrix[5] = cell_size[4];
+  matrix[6] = cell_size[3];
+  matrix[7] = cell_size[4];
+  matrix[8] = cell_size[5];
+  // in order to check the periodic distance, translate one of the vectors into each of the 27 neighbouring cells
+  for (N[0]=-1;N[0]<=1;N[0]++)
+    for (N[1]=-1;N[1]<=1;N[1]++)
+      for (N[2]=-1;N[2]<=1;N[2]++) {
+        // create the translation vector
+        TranslationVector.Zero();
+        for (int i=NDIM;i--;)
+          TranslationVector.x[i] = (double)N[i];
+        TranslationVector.MatrixMultiplication(matrix);
+        // add onto the original vector to compare with
+        Shiftedy.CopyVector(y);
+        Shiftedy.AddVector(&TranslationVector);
+        // get distance and compare with minimum so far
+        tmp = DistanceSquared(&Shiftedy);
+        if (tmp < res) res = tmp;
+      }
+  return (res);
 };
 
@@ -128,27 +128,27 @@
 void Vector::KeepPeriodic(ofstream *out, double *matrix)
 {
-//	int N[NDIM];
-//	bool flag = false;
-	//vector Shifted, TranslationVector;
-	Vector TestVector;
-//	*out << Verbose(1) << "Begin of KeepPeriodic." << endl;
-//	*out << Verbose(2) << "Vector is: ";
-//	Output(out);
-//	*out << endl;
-	TestVector.CopyVector(this);
-	TestVector.InverseMatrixMultiplication(matrix);
-	for(int i=NDIM;i--;) { // correct periodically
-		if (TestVector.x[i] < 0) {	// get every coefficient into the interval [0,1)
-			TestVector.x[i] += ceil(TestVector.x[i]);
-		} else {
-			TestVector.x[i] -= floor(TestVector.x[i]);
-		}
-	}
-	TestVector.MatrixMultiplication(matrix);
-	CopyVector(&TestVector);
-//	*out << Verbose(2) << "New corrected vector is: ";
-//	Output(out);
-//	*out << endl;
-//	*out << Verbose(1) << "End of KeepPeriodic." << endl;
+//  int N[NDIM];
+//  bool flag = false;
+  //vector Shifted, TranslationVector;
+  Vector TestVector;
+//  *out << Verbose(1) << "Begin of KeepPeriodic." << endl;
+//  *out << Verbose(2) << "Vector is: ";
+//  Output(out);
+//  *out << endl;
+  TestVector.CopyVector(this);
+  TestVector.InverseMatrixMultiplication(matrix);
+  for(int i=NDIM;i--;) { // correct periodically
+    if (TestVector.x[i] < 0) {  // get every coefficient into the interval [0,1)
+      TestVector.x[i] += ceil(TestVector.x[i]);
+    } else {
+      TestVector.x[i] -= floor(TestVector.x[i]);
+    }
+  }
+  TestVector.MatrixMultiplication(matrix);
+  CopyVector(&TestVector);
+//  *out << Verbose(2) << "New corrected vector is: ";
+//  Output(out);
+//  *out << endl;
+//  *out << Verbose(1) << "End of KeepPeriodic." << endl;
 };
 
@@ -159,24 +159,24 @@
 double Vector::ScalarProduct(const Vector *y) const
 {
-	double res = 0.;
-	for (int i=NDIM;i--;)
-		res += x[i]*y->x[i];
-	return (res);
+  double res = 0.;
+  for (int i=NDIM;i--;)
+    res += x[i]*y->x[i];
+  return (res);
 };
 
 
 /** Calculates VectorProduct between this and another vector.
- *	-# returns the Product in place of vector from which it was initiated
- *	-# ATTENTION: Only three dim.
- *	\param *y array to vector with which to calculate crossproduct
- *	\return \f$ x \times y \f&
+ *  -# returns the Product in place of vector from which it was initiated
+ *  -# ATTENTION: Only three dim.
+ *  \param *y array to vector with which to calculate crossproduct
+ *  \return \f$ x \times y \f&
  */
 void Vector::VectorProduct(const Vector *y)
 {
-	Vector tmp;
-	tmp.x[0] = x[1]* (y->x[2]) - x[2]* (y->x[1]);
-	tmp.x[1] = x[2]* (y->x[0]) - x[0]* (y->x[2]);
-	tmp.x[2] = x[0]* (y->x[1]) - x[1]* (y->x[0]);
-	this->CopyVector(&tmp);
+  Vector tmp;
+  tmp.x[0] = x[1]* (y->x[2]) - x[2]* (y->x[1]);
+  tmp.x[1] = x[2]* (y->x[0]) - x[0]* (y->x[2]);
+  tmp.x[2] = x[0]* (y->x[1]) - x[1]* (y->x[0]);
+  this->CopyVector(&tmp);
 
 };
@@ -189,9 +189,96 @@
 void Vector::ProjectOntoPlane(const Vector *y)
 {
-	Vector tmp;
-	tmp.CopyVector(y);
-	tmp.Normalize();
-	tmp.Scale(ScalarProduct(&tmp));
-	this->SubtractVector(&tmp);
+  Vector tmp;
+  tmp.CopyVector(y);
+  tmp.Normalize();
+  tmp.Scale(ScalarProduct(&tmp));
+  this->SubtractVector(&tmp);
+};
+
+/** Calculates the intersection point between a line defined by \a *LineVector and \a *LineVector2 and a plane defined by \a *Normal and \a *PlaneOffset.
+ * According to [Bronstein] the vectorial plane equation is:
+ *   -# \f$\stackrel{r}{\rightarrow} \cdot \stackrel{N}{\rightarrow} + D = 0\f$,
+ * where \f$\stackrel{r}{\rightarrow}\f$ is the vector to be testet, \f$\stackrel{N}{\rightarrow}\f$ is the plane's normal vector and
+ * \f$D = - \stackrel{a}{\rightarrow} \stackrel{N}{\rightarrow}\f$, the offset with respect to origin, if \f$\stackrel{a}{\rightarrow}\f$,
+ * is an offset vector onto the plane. The line is parametrized by \f$\stackrel{x}{\rightarrow} + k \stackrel{t}{\rightarrow}\f$, where
+ * \f$\stackrel{x}{\rightarrow}\f$ is the offset and \f$\stackrel{t}{\rightarrow}\f$ the directional vector (NOTE: No need to normalize
+ * the latter). Inserting the parametrized form into the plane equation and solving for \f$k\f$, which we insert then into the parametrization
+ * of the line yields the intersection point on the plane.
+ * \param *out output stream for debugging
+ * \param *PlaneNormal Plane's normal vector
+ * \param *PlaneOffset Plane's offset vector
+ * \param *LineVector first vector of line
+ * \param *LineVector2 second vector of line
+ * \return true -  \a this contains intersection point on return, false - line is parallel to plane
+ */
+bool Vector::GetIntersectionWithPlane(ofstream *out, Vector *PlaneNormal, Vector *PlaneOffset, Vector *LineVector, Vector *LineVector2)
+{
+  double factor;
+  Vector Direction;
+
+  // find intersection of a line defined by Offset and Direction with a  plane defined by triangle
+  Direction.CopyVector(LineVector2);
+  Direction.SubtractVector(LineVector);
+  if (Direction.ScalarProduct(PlaneNormal) < MYEPSILON)
+    return false;
+  factor = LineVector->ScalarProduct(PlaneNormal)*(-PlaneOffset->ScalarProduct(PlaneNormal))/(Direction.ScalarProduct(PlaneNormal));
+  Direction.Scale(factor);
+  CopyVector(LineVector);
+  SubtractVector(&Direction);
+
+  // test whether resulting vector really is on plane
+  Direction.CopyVector(this);
+  Direction.SubtractVector(PlaneOffset);
+  if (Direction.ScalarProduct(PlaneNormal) > MYEPSILON)
+    return true;
+  else
+    return false;
+};
+
+/** Calculates the intersection of the two lines that are both on the same plane.
+ * Note that we do not check whether they are on the same plane.
+ * \param *out output stream for debugging
+ * \param *Line1a first vector of first line
+ * \param *Line1b second vector of first line
+ * \param *Line2a first vector of second line
+ * \param *Line2b second vector of second line
+ * \return true - \a this will contain the intersection on return, false - lines are parallel
+ */
+bool Vector::GetIntersectionOfTwoLinesOnPlane(ofstream *out, Vector *Line1a, Vector *Line1b, Vector *Line2a, Vector *Line2b)
+{
+  double k1,a1,h1,b1,k2,a2,h2,b2;
+  // equation for line 1
+  if (fabs(Line1a->x[0] - Line2a->x[0]) < MYEPSILON) {
+    k1 = 0;
+    h1 = 0;
+  } else {
+    k1 = (Line1a->x[1] - Line2a->x[1])/(Line1a->x[0] - Line2a->x[0]);
+    h1 = (Line1a->x[2] - Line2a->x[2])/(Line1a->x[0] - Line2a->x[0]);
+  }
+  a1 = 0.5*((Line1a->x[1] + Line2a->x[1]) - k1*(Line1a->x[0] + Line2a->x[0]));
+  b1 = 0.5*((Line1a->x[2] + Line2a->x[2]) - h1*(Line1a->x[0] + Line2a->x[0]));
+
+  // equation for line 2
+  if (fabs(Line2a->x[0] - Line2a->x[0]) < MYEPSILON) {
+    k1 = 0;
+    h1 = 0;
+  } else {
+    k1 = (Line2a->x[1] - Line2a->x[1])/(Line2a->x[0] - Line2a->x[0]);
+    h1 = (Line2a->x[2] - Line2a->x[2])/(Line2a->x[0] - Line2a->x[0]);
+  }
+  a1 = 0.5*((Line2a->x[1] + Line2a->x[1]) - k1*(Line2a->x[0] + Line2a->x[0]));
+  b1 = 0.5*((Line2a->x[2] + Line2a->x[2]) - h1*(Line2a->x[0] + Line2a->x[0]));
+
+  // calculate cross point
+  if (fabs((a1-a2)*(h1-h2) - (b1-b2)*(k1-k2)) < MYEPSILON) {
+    x[0] = (a2-a1)/(k1-k2);
+    x[1] = (k1*a2-k2*a1)/(k1-k2);
+    x[2] = (h1*b2-h2*b1)/(h1-h2);
+    *out << Verbose(4) << "Lines do intersect at " << this << "." << endl;
+    return true;
+  } else {
+    *out << Verbose(4) << "Lines do not intersect." << endl;
+    return false;
+  }
 };
 
@@ -202,5 +289,5 @@
 double Vector::Projection(const Vector *y) const
 {
-	return (ScalarProduct(y));
+  return (ScalarProduct(y));
 };
 
@@ -210,8 +297,16 @@
 double Vector::Norm() const
 {
-	double res = 0.;
-	for (int i=NDIM;i--;)
-		res += this->x[i]*this->x[i];
-	return (sqrt(res));
+  double res = 0.;
+  for (int i=NDIM;i--;)
+    res += this->x[i]*this->x[i];
+  return (sqrt(res));
+};
+
+/** Calculates squared norm of this vector.
+ * \return \f$|x|^2\f$
+ */
+double Vector::NormSquared() const
+{
+  return (ScalarProduct(this));
 };
 
@@ -220,10 +315,10 @@
 void Vector::Normalize()
 {
-	double res = 0.;
-	for (int i=NDIM;i--;)
-		res += this->x[i]*this->x[i];
-	if (fabs(res) > MYEPSILON)
-		res = 1./sqrt(res);
-	Scale(&res);
+  double res = 0.;
+  for (int i=NDIM;i--;)
+    res += this->x[i]*this->x[i];
+  if (fabs(res) > MYEPSILON)
+    res = 1./sqrt(res);
+  Scale(&res);
 };
 
@@ -232,6 +327,6 @@
 void Vector::Zero()
 {
-	for (int i=NDIM;i--;)
-		this->x[i] = 0.;
+  for (int i=NDIM;i--;)
+    this->x[i] = 0.;
 };
 
@@ -240,6 +335,6 @@
 void Vector::One(double one)
 {
-	for (int i=NDIM;i--;)
-		this->x[i] = one;
+  for (int i=NDIM;i--;)
+    this->x[i] = one;
 };
 
@@ -248,7 +343,7 @@
 void Vector::Init(double x1, double x2, double x3)
 {
-	x[0] = x1;
-	x[1] = x2;
-	x[2] = x3;
+  x[0] = x1;
+  x[1] = x2;
+  x[2] = x3;
 };
 
@@ -267,5 +362,8 @@
 double Vector::Angle(const Vector *y) const
 {
-  double angle = this->ScalarProduct(y)/Norm()/y->Norm();
+  double norm1 = Norm(), norm2 = y->Norm();
+  double angle = 1;
+  if ((fabs(norm1) > MYEPSILON) && (fabs(norm2) > MYEPSILON))
+    angle = this->ScalarProduct(y)/norm1/norm2;
   // -1-MYEPSILON occured due to numerical imprecision, catch ...
   //cout << Verbose(2) << "INFO: acos(-1) = " << acos(-1) << ", acos(-1+MYEPSILON) = " << acos(-1+MYEPSILON) << ", acos(-1-MYEPSILON) = " << acos(-1-MYEPSILON) << "." << endl;
@@ -274,5 +372,5 @@
   if (angle > 1)
     angle = 1;
-	return acos(angle);
+  return acos(angle);
 };
 
@@ -283,19 +381,19 @@
 void Vector::RotateVector(const Vector *axis, const double alpha)
 {
-	Vector a,y;
-	// normalise this vector with respect to axis
-	a.CopyVector(this);
-	a.Scale(Projection(axis));
-	SubtractVector(&a);
-	// construct normal vector
-	y.MakeNormalVector(axis,this);
-	y.Scale(Norm());
-	// scale normal vector by sine and this vector by cosine
-	y.Scale(sin(alpha));
-	Scale(cos(alpha));
-	// add scaled normal vector onto this vector
-	AddVector(&y);
-	// add part in axis direction
-	AddVector(&a);
+  Vector a,y;
+  // normalise this vector with respect to axis
+  a.CopyVector(this);
+  a.Scale(Projection(axis));
+  SubtractVector(&a);
+  // construct normal vector
+  y.MakeNormalVector(axis,this);
+  y.Scale(Norm());
+  // scale normal vector by sine and this vector by cosine
+  y.Scale(sin(alpha));
+  Scale(cos(alpha));
+  // add scaled normal vector onto this vector
+  AddVector(&y);
+  // add part in axis direction
+  AddVector(&a);
 };
 
@@ -307,6 +405,6 @@
 Vector& operator+=(Vector& a, const Vector& b)
 {
-	a.AddVector(&b);
-	return a;
+  a.AddVector(&b);
+  return a;
 };
 /** factor each component of \a a times a double \a m.
@@ -317,9 +415,9 @@
 Vector& operator*=(Vector& a, const double m)
 {
-	a.Scale(m);
-	return a;
-};
-
-/** Sums two vectors \a	and \b component-wise.
+  a.Scale(m);
+  return a;
+};
+
+/** Sums two vectors \a  and \b component-wise.
  * \param a first vector
  * \param b second vector
@@ -328,8 +426,8 @@
 Vector& operator+(const Vector& a, const Vector& b)
 {
-	Vector *x = new Vector;
-	x->CopyVector(&a);
-	x->AddVector(&b);
-	return *x;
+  Vector *x = new Vector;
+  x->CopyVector(&a);
+  x->AddVector(&b);
+  return *x;
 };
 
@@ -341,8 +439,8 @@
 Vector& operator*(const Vector& a, const double m)
 {
-	Vector *x = new Vector;
-	x->CopyVector(&a);
-	x->Scale(m);
-	return *x;
+  Vector *x = new Vector;
+  x->CopyVector(&a);
+  x->Scale(m);
+  return *x;
 };
 
@@ -353,27 +451,27 @@
 bool Vector::Output(ofstream *out) const
 {
-	if (out != NULL) {
-		*out << "(";
-		for (int i=0;i<NDIM;i++) {
-			*out << x[i];
-			if (i != 2)
-				*out << ",";
-		}
-		*out << ")";
-		return true;
-	} else
-		return false;
+  if (out != NULL) {
+    *out << "(";
+    for (int i=0;i<NDIM;i++) {
+      *out << x[i];
+      if (i != 2)
+        *out << ",";
+    }
+    *out << ")";
+    return true;
+  } else
+    return false;
 };
 
 ostream& operator<<(ostream& ost, const Vector& m)
 {
-	ost << "(";
-	for (int i=0;i<NDIM;i++) {
-		ost << m.x[i];
-		if (i != 2)
-			ost << ",";
-	}
-	ost << ")";
-	return ost;
+  ost << "(";
+  for (int i=0;i<NDIM;i++) {
+    ost << m.x[i];
+    if (i != 2)
+      ost << ",";
+  }
+  ost << ")";
+  return ost;
 };
 
@@ -383,18 +481,18 @@
 void Vector::Scale(double **factor)
 {
-	for (int i=NDIM;i--;)
-		x[i] *= (*factor)[i];
+  for (int i=NDIM;i--;)
+    x[i] *= (*factor)[i];
 };
 
 void Vector::Scale(double *factor)
 {
-	for (int i=NDIM;i--;)
-		x[i] *= *factor;
+  for (int i=NDIM;i--;)
+    x[i] *= *factor;
 };
 
 void Vector::Scale(double factor)
 {
-	for (int i=NDIM;i--;)
-		x[i] *= factor;
+  for (int i=NDIM;i--;)
+    x[i] *= factor;
 };
 
@@ -404,6 +502,6 @@
 void Vector::Translate(const Vector *trans)
 {
-	for (int i=NDIM;i--;)
-		x[i] += trans->x[i];
+  for (int i=NDIM;i--;)
+    x[i] += trans->x[i];
 };
 
@@ -413,47 +511,74 @@
 void Vector::MatrixMultiplication(double *M)
 {
-	Vector C;
-	// do the matrix multiplication
-	C.x[0] = M[0]*x[0]+M[3]*x[1]+M[6]*x[2];
-	C.x[1] = M[1]*x[0]+M[4]*x[1]+M[7]*x[2];
-	C.x[2] = M[2]*x[0]+M[5]*x[1]+M[8]*x[2];
-	// transfer the result into this
-	for (int i=NDIM;i--;)
-		x[i] = C.x[i];
-};
-
-/** Do a matrix multiplication with \a *matrix' inverse.
+  Vector C;
+  // do the matrix multiplication
+  C.x[0] = M[0]*x[0]+M[3]*x[1]+M[6]*x[2];
+  C.x[1] = M[1]*x[0]+M[4]*x[1]+M[7]*x[2];
+  C.x[2] = M[2]*x[0]+M[5]*x[1]+M[8]*x[2];
+  // transfer the result into this
+  for (int i=NDIM;i--;)
+    x[i] = C.x[i];
+};
+
+/** Calculate the inverse of a 3x3 matrix.
  * \param *matrix NDIM_NDIM array
  */
+double * Vector::InverseMatrix(double *A)
+{
+  double *B = (double *) Malloc(sizeof(double)*NDIM*NDIM, "Vector::InverseMatrix: *B");
+  double detA = RDET3(A);
+  double detAReci;
+
+  for (int i=0;i<NDIM*NDIM;++i)
+    B[i] = 0.;
+  // calculate the inverse B
+  if (fabs(detA) > MYEPSILON) {;  // RDET3(A) yields precisely zero if A irregular
+    detAReci = 1./detA;
+    B[0] =  detAReci*RDET2(A[4],A[5],A[7],A[8]);    // A_11
+    B[1] = -detAReci*RDET2(A[1],A[2],A[7],A[8]);    // A_12
+    B[2] =  detAReci*RDET2(A[1],A[2],A[4],A[5]);    // A_13
+    B[3] = -detAReci*RDET2(A[3],A[5],A[6],A[8]);    // A_21
+    B[4] =  detAReci*RDET2(A[0],A[2],A[6],A[8]);    // A_22
+    B[5] = -detAReci*RDET2(A[0],A[2],A[3],A[5]);    // A_23
+    B[6] =  detAReci*RDET2(A[3],A[4],A[6],A[7]);    // A_31
+    B[7] = -detAReci*RDET2(A[0],A[1],A[6],A[7]);    // A_32
+    B[8] =  detAReci*RDET2(A[0],A[1],A[3],A[4]);    // A_33
+  }
+  return B;
+};
+
+/** Do a matrix multiplication with the \a *A' inverse.
+ * \param *matrix NDIM_NDIM array
+ */
 void Vector::InverseMatrixMultiplication(double *A)
 {
-	Vector C;
-	double B[NDIM*NDIM];
-	double detA = RDET3(A);
-	double detAReci;
-
-	// calculate the inverse B
-	if (fabs(detA) > MYEPSILON) {;	// RDET3(A) yields precisely zero if A irregular
-		detAReci = 1./detA;
-		B[0] =	detAReci*RDET2(A[4],A[5],A[7],A[8]);		// A_11
-		B[1] = -detAReci*RDET2(A[1],A[2],A[7],A[8]);		// A_12
-		B[2] =	detAReci*RDET2(A[1],A[2],A[4],A[5]);		// A_13
-		B[3] = -detAReci*RDET2(A[3],A[5],A[6],A[8]);		// A_21
-		B[4] =	detAReci*RDET2(A[0],A[2],A[6],A[8]);		// A_22
-		B[5] = -detAReci*RDET2(A[0],A[2],A[3],A[5]);		// A_23
-		B[6] =	detAReci*RDET2(A[3],A[4],A[6],A[7]);		// A_31
-		B[7] = -detAReci*RDET2(A[0],A[1],A[6],A[7]);		// A_32
-		B[8] =	detAReci*RDET2(A[0],A[1],A[3],A[4]);		// A_33
-
-		// do the matrix multiplication
-		C.x[0] = B[0]*x[0]+B[3]*x[1]+B[6]*x[2];
-		C.x[1] = B[1]*x[0]+B[4]*x[1]+B[7]*x[2];
-		C.x[2] = B[2]*x[0]+B[5]*x[1]+B[8]*x[2];
-		// transfer the result into this
-		for (int i=NDIM;i--;)
-			x[i] = C.x[i];
-	} else {
-		cerr << "ERROR: inverse of matrix does not exists!" << endl;
-	}
+  Vector C;
+  double B[NDIM*NDIM];
+  double detA = RDET3(A);
+  double detAReci;
+
+  // calculate the inverse B
+  if (fabs(detA) > MYEPSILON) {;  // RDET3(A) yields precisely zero if A irregular
+    detAReci = 1./detA;
+    B[0] =  detAReci*RDET2(A[4],A[5],A[7],A[8]);    // A_11
+    B[1] = -detAReci*RDET2(A[1],A[2],A[7],A[8]);    // A_12
+    B[2] =  detAReci*RDET2(A[1],A[2],A[4],A[5]);    // A_13
+    B[3] = -detAReci*RDET2(A[3],A[5],A[6],A[8]);    // A_21
+    B[4] =  detAReci*RDET2(A[0],A[2],A[6],A[8]);    // A_22
+    B[5] = -detAReci*RDET2(A[0],A[2],A[3],A[5]);    // A_23
+    B[6] =  detAReci*RDET2(A[3],A[4],A[6],A[7]);    // A_31
+    B[7] = -detAReci*RDET2(A[0],A[1],A[6],A[7]);    // A_32
+    B[8] =  detAReci*RDET2(A[0],A[1],A[3],A[4]);    // A_33
+
+    // do the matrix multiplication
+    C.x[0] = B[0]*x[0]+B[3]*x[1]+B[6]*x[2];
+    C.x[1] = B[1]*x[0]+B[4]*x[1]+B[7]*x[2];
+    C.x[2] = B[2]*x[0]+B[5]*x[1]+B[8]*x[2];
+    // transfer the result into this
+    for (int i=NDIM;i--;)
+      x[i] = C.x[i];
+  } else {
+    cerr << "ERROR: inverse of matrix does not exists: det A = " << detA << "." << endl;
+  }
 };
 
@@ -468,6 +593,6 @@
 void Vector::LinearCombinationOfVectors(const Vector *x1, const Vector *x2, const Vector *x3, double *factors)
 {
-	for(int i=NDIM;i--;)
-		x[i] = factors[0]*x1->x[i] + factors[1]*x2->x[i] + factors[2]*x3->x[i];
+  for(int i=NDIM;i--;)
+    x[i] = factors[0]*x1->x[i] + factors[1]*x2->x[i] + factors[2]*x3->x[i];
 };
 
@@ -477,15 +602,15 @@
 void Vector::Mirror(const Vector *n)
 {
-	double projection;
-	projection = ScalarProduct(n)/n->ScalarProduct(n);		// remove constancy from n (keep as logical one)
-	// withdraw projected vector twice from original one
-	cout << Verbose(1) << "Vector: ";
-	Output((ofstream *)&cout);
-	cout << "\t";
-	for (int i=NDIM;i--;)
-		x[i] -= 2.*projection*n->x[i];
-	cout << "Projected vector: ";
-	Output((ofstream *)&cout);
-	cout << endl;
+  double projection;
+  projection = ScalarProduct(n)/n->ScalarProduct(n);    // remove constancy from n (keep as logical one)
+  // withdraw projected vector twice from original one
+  cout << Verbose(1) << "Vector: ";
+  Output((ofstream *)&cout);
+  cout << "\t";
+  for (int i=NDIM;i--;)
+    x[i] -= 2.*projection*n->x[i];
+  cout << "Projected vector: ";
+  Output((ofstream *)&cout);
+  cout << endl;
 };
 
@@ -499,27 +624,27 @@
 bool Vector::MakeNormalVector(const Vector *y1, const Vector *y2, const Vector *y3)
 {
-	Vector x1, x2;
-
-	x1.CopyVector(y1);
-	x1.SubtractVector(y2);
-	x2.CopyVector(y3);
-	x2.SubtractVector(y2);
-	if ((fabs(x1.Norm()) < MYEPSILON) || (fabs(x2.Norm()) < MYEPSILON) || (fabs(x1.Angle(&x2)) < MYEPSILON)) {
-		cout << Verbose(4) << "Given vectors are linear dependent." << endl;
-		return false;
-	}
-//	cout << Verbose(4) << "relative, first plane coordinates:";
-//	x1.Output((ofstream *)&cout);
-//	cout << endl;
-//	cout << Verbose(4) << "second plane coordinates:";
-//	x2.Output((ofstream *)&cout);
-//	cout << endl;
-
-	this->x[0] = (x1.x[1]*x2.x[2] - x1.x[2]*x2.x[1]);
-	this->x[1] = (x1.x[2]*x2.x[0] - x1.x[0]*x2.x[2]);
-	this->x[2] = (x1.x[0]*x2.x[1] - x1.x[1]*x2.x[0]);
-	Normalize();
-
-	return true;
+  Vector x1, x2;
+
+  x1.CopyVector(y1);
+  x1.SubtractVector(y2);
+  x2.CopyVector(y3);
+  x2.SubtractVector(y2);
+  if ((fabs(x1.Norm()) < MYEPSILON) || (fabs(x2.Norm()) < MYEPSILON) || (fabs(x1.Angle(&x2)) < MYEPSILON)) {
+    cout << Verbose(4) << "Given vectors are linear dependent." << endl;
+    return false;
+  }
+//  cout << Verbose(4) << "relative, first plane coordinates:";
+//  x1.Output((ofstream *)&cout);
+//  cout << endl;
+//  cout << Verbose(4) << "second plane coordinates:";
+//  x2.Output((ofstream *)&cout);
+//  cout << endl;
+
+  this->x[0] = (x1.x[1]*x2.x[2] - x1.x[2]*x2.x[1]);
+  this->x[1] = (x1.x[2]*x2.x[0] - x1.x[0]*x2.x[2]);
+  this->x[2] = (x1.x[0]*x2.x[1] - x1.x[1]*x2.x[0]);
+  Normalize();
+
+  return true;
 };
 
@@ -535,25 +660,25 @@
 bool Vector::MakeNormalVector(const Vector *y1, const Vector *y2)
 {
-	Vector x1,x2;
-	x1.CopyVector(y1);
-	x2.CopyVector(y2);
-	Zero();
-	if ((fabs(x1.Norm()) < MYEPSILON) || (fabs(x2.Norm()) < MYEPSILON) || (fabs(x1.Angle(&x2)) < MYEPSILON)) {
-		cout << Verbose(4) << "Given vectors are linear dependent." << endl;
-		return false;
-	}
-//	cout << Verbose(4) << "relative, first plane coordinates:";
-//	x1.Output((ofstream *)&cout);
-//	cout << endl;
-//	cout << Verbose(4) << "second plane coordinates:";
-//	x2.Output((ofstream *)&cout);
-//	cout << endl;
-
-	this->x[0] = (x1.x[1]*x2.x[2] - x1.x[2]*x2.x[1]);
-	this->x[1] = (x1.x[2]*x2.x[0] - x1.x[0]*x2.x[2]);
-	this->x[2] = (x1.x[0]*x2.x[1] - x1.x[1]*x2.x[0]);
-	Normalize();
-
-	return true;
+  Vector x1,x2;
+  x1.CopyVector(y1);
+  x2.CopyVector(y2);
+  Zero();
+  if ((fabs(x1.Norm()) < MYEPSILON) || (fabs(x2.Norm()) < MYEPSILON) || (fabs(x1.Angle(&x2)) < MYEPSILON)) {
+    cout << Verbose(4) << "Given vectors are linear dependent." << endl;
+    return false;
+  }
+//  cout << Verbose(4) << "relative, first plane coordinates:";
+//  x1.Output((ofstream *)&cout);
+//  cout << endl;
+//  cout << Verbose(4) << "second plane coordinates:";
+//  x2.Output((ofstream *)&cout);
+//  cout << endl;
+
+  this->x[0] = (x1.x[1]*x2.x[2] - x1.x[2]*x2.x[1]);
+  this->x[1] = (x1.x[2]*x2.x[0] - x1.x[0]*x2.x[2]);
+  this->x[2] = (x1.x[0]*x2.x[1] - x1.x[1]*x2.x[0]);
+  Normalize();
+
+  return true;
 };
 
@@ -565,13 +690,13 @@
 bool Vector::MakeNormalVector(const Vector *y1)
 {
-	bool result = false;
-	Vector x1;
-	x1.CopyVector(y1);
-	x1.Scale(x1.Projection(this));
-	SubtractVector(&x1);
-	for (int i=NDIM;i--;)
-		result = result || (fabs(x[i]) > MYEPSILON);
-
-	return result;
+  bool result = false;
+  Vector x1;
+  x1.CopyVector(y1);
+  x1.Scale(x1.Projection(this));
+  SubtractVector(&x1);
+  for (int i=NDIM;i--;)
+    result = result || (fabs(x[i]) > MYEPSILON);
+
+  return result;
 };
 
@@ -584,40 +709,40 @@
 bool Vector::GetOneNormalVector(const Vector *GivenVector)
 {
-	int Components[NDIM]; // contains indices of non-zero components
-	int Last = 0;	 // count the number of non-zero entries in vector
-	int j;	// loop variables
-	double norm;
-
-	cout << Verbose(4);
-	GivenVector->Output((ofstream *)&cout);
-	cout << endl;
-	for (j=NDIM;j--;)
-		Components[j] = -1;
-	// find two components != 0
-	for (j=0;j<NDIM;j++)
-		if (fabs(GivenVector->x[j]) > MYEPSILON)
-			Components[Last++] = j;
-	cout << Verbose(4) << Last << " Components != 0: (" << Components[0] << "," << Components[1] << "," << Components[2] << ")" << endl;
-
-	switch(Last) {
-		case 3:	// threecomponent system
-		case 2:	// two component system
-			norm = sqrt(1./(GivenVector->x[Components[1]]*GivenVector->x[Components[1]]) + 1./(GivenVector->x[Components[0]]*GivenVector->x[Components[0]]));
-			x[Components[2]] = 0.;
-			// in skp both remaining parts shall become zero but with opposite sign and third is zero
-			x[Components[1]] = -1./GivenVector->x[Components[1]] / norm;
-			x[Components[0]] = 1./GivenVector->x[Components[0]] / norm;
-			return true;
-			break;
-		case 1: // one component system
-			// set sole non-zero component to 0, and one of the other zero component pendants to 1
-			x[(Components[0]+2)%NDIM] = 0.;
-			x[(Components[0]+1)%NDIM] = 1.;
-			x[Components[0]] = 0.;
-			return true;
-			break;
-		default:
-			return false;
-	}
+  int Components[NDIM]; // contains indices of non-zero components
+  int Last = 0;   // count the number of non-zero entries in vector
+  int j;  // loop variables
+  double norm;
+
+  cout << Verbose(4);
+  GivenVector->Output((ofstream *)&cout);
+  cout << endl;
+  for (j=NDIM;j--;)
+    Components[j] = -1;
+  // find two components != 0
+  for (j=0;j<NDIM;j++)
+    if (fabs(GivenVector->x[j]) > MYEPSILON)
+      Components[Last++] = j;
+  cout << Verbose(4) << Last << " Components != 0: (" << Components[0] << "," << Components[1] << "," << Components[2] << ")" << endl;
+
+  switch(Last) {
+    case 3:  // threecomponent system
+    case 2:  // two component system
+      norm = sqrt(1./(GivenVector->x[Components[1]]*GivenVector->x[Components[1]]) + 1./(GivenVector->x[Components[0]]*GivenVector->x[Components[0]]));
+      x[Components[2]] = 0.;
+      // in skp both remaining parts shall become zero but with opposite sign and third is zero
+      x[Components[1]] = -1./GivenVector->x[Components[1]] / norm;
+      x[Components[0]] = 1./GivenVector->x[Components[0]] / norm;
+      return true;
+      break;
+    case 1: // one component system
+      // set sole non-zero component to 0, and one of the other zero component pendants to 1
+      x[(Components[0]+2)%NDIM] = 0.;
+      x[(Components[0]+1)%NDIM] = 1.;
+      x[Components[0]] = 0.;
+      return true;
+      break;
+    default:
+      return false;
+  }
 };
 
@@ -630,10 +755,10 @@
 double Vector::CutsPlaneAt(Vector *A, Vector *B, Vector *C)
 {
-//	cout << Verbose(3) << "For comparison: ";
-//	cout << "A " << A->Projection(this) << "\t";
-//	cout << "B " << B->Projection(this) << "\t";
-//	cout << "C " << C->Projection(this) << "\t";
-//	cout << endl;
-	return A->Projection(this);
+//  cout << Verbose(3) << "For comparison: ";
+//  cout << "A " << A->Projection(this) << "\t";
+//  cout << "B " << B->Projection(this) << "\t";
+//  cout << "C " << C->Projection(this) << "\t";
+//  cout << endl;
+  return A->Projection(this);
 };
 
